<?php
 
 
 

namespace PhpWA\Protocol\Proto\Message;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class HistorySyncNotification extends \Google\Protobuf\Internal\Message
{
    


    protected $fileSha256 = null;
    


    protected $fileLength = null;
    


    protected $mediaKey = null;
    


    protected $fileEncSha256 = null;
    


    protected $directPath = null;
    


    protected $syncType = null;
    


    protected $chunkOrder = null;
    


    protected $originalMessageId = null;
    


    protected $progress = null;
    


    protected $oldestMsgInChunkTimestampSec = null;
    


    protected $initialHistBootstrapInlinePayload = null;
    


    protected $peerDataRequestSessionId = null;
    


    protected $fullHistorySyncOnDemandRequestMetadata = null;
    


    protected $encHandle = null;
    


    protected $messageAccessStatus = null;

    






















    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getFileSha256()
    {
        return isset($this->fileSha256) ? $this->fileSha256 : '';
    }

    public function hasFileSha256()
    {
        return isset($this->fileSha256);
    }

    public function clearFileSha256()
    {
        unset($this->fileSha256);
    }

    




    public function setFileSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->fileSha256 = $var;

        return $this;
    }

    



    public function getFileLength()
    {
        return isset($this->fileLength) ? $this->fileLength : 0;
    }

    public function hasFileLength()
    {
        return isset($this->fileLength);
    }

    public function clearFileLength()
    {
        unset($this->fileLength);
    }

    




    public function setFileLength($var)
    {
        GPBUtil::checkUint64($var);
        $this->fileLength = $var;

        return $this;
    }

    



    public function getMediaKey()
    {
        return isset($this->mediaKey) ? $this->mediaKey : '';
    }

    public function hasMediaKey()
    {
        return isset($this->mediaKey);
    }

    public function clearMediaKey()
    {
        unset($this->mediaKey);
    }

    




    public function setMediaKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->mediaKey = $var;

        return $this;
    }

    



    public function getFileEncSha256()
    {
        return isset($this->fileEncSha256) ? $this->fileEncSha256 : '';
    }

    public function hasFileEncSha256()
    {
        return isset($this->fileEncSha256);
    }

    public function clearFileEncSha256()
    {
        unset($this->fileEncSha256);
    }

    




    public function setFileEncSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->fileEncSha256 = $var;

        return $this;
    }

    



    public function getDirectPath()
    {
        return isset($this->directPath) ? $this->directPath : '';
    }

    public function hasDirectPath()
    {
        return isset($this->directPath);
    }

    public function clearDirectPath()
    {
        unset($this->directPath);
    }

    




    public function setDirectPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->directPath = $var;

        return $this;
    }

    



    public function getSyncType()
    {
        return isset($this->syncType) ? $this->syncType : 0;
    }

    public function hasSyncType()
    {
        return isset($this->syncType);
    }

    public function clearSyncType()
    {
        unset($this->syncType);
    }

    




    public function setSyncType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\HistorySyncType::class);
        $this->syncType = $var;

        return $this;
    }

    



    public function getChunkOrder()
    {
        return isset($this->chunkOrder) ? $this->chunkOrder : 0;
    }

    public function hasChunkOrder()
    {
        return isset($this->chunkOrder);
    }

    public function clearChunkOrder()
    {
        unset($this->chunkOrder);
    }

    




    public function setChunkOrder($var)
    {
        GPBUtil::checkUint32($var);
        $this->chunkOrder = $var;

        return $this;
    }

    



    public function getOriginalMessageId()
    {
        return isset($this->originalMessageId) ? $this->originalMessageId : '';
    }

    public function hasOriginalMessageId()
    {
        return isset($this->originalMessageId);
    }

    public function clearOriginalMessageId()
    {
        unset($this->originalMessageId);
    }

    




    public function setOriginalMessageId($var)
    {
        GPBUtil::checkString($var, True);
        $this->originalMessageId = $var;

        return $this;
    }

    



    public function getProgress()
    {
        return isset($this->progress) ? $this->progress : 0;
    }

    public function hasProgress()
    {
        return isset($this->progress);
    }

    public function clearProgress()
    {
        unset($this->progress);
    }

    




    public function setProgress($var)
    {
        GPBUtil::checkUint32($var);
        $this->progress = $var;

        return $this;
    }

    



    public function getOldestMsgInChunkTimestampSec()
    {
        return isset($this->oldestMsgInChunkTimestampSec) ? $this->oldestMsgInChunkTimestampSec : 0;
    }

    public function hasOldestMsgInChunkTimestampSec()
    {
        return isset($this->oldestMsgInChunkTimestampSec);
    }

    public function clearOldestMsgInChunkTimestampSec()
    {
        unset($this->oldestMsgInChunkTimestampSec);
    }

    




    public function setOldestMsgInChunkTimestampSec($var)
    {
        GPBUtil::checkInt64($var);
        $this->oldestMsgInChunkTimestampSec = $var;

        return $this;
    }

    



    public function getInitialHistBootstrapInlinePayload()
    {
        return isset($this->initialHistBootstrapInlinePayload) ? $this->initialHistBootstrapInlinePayload : '';
    }

    public function hasInitialHistBootstrapInlinePayload()
    {
        return isset($this->initialHistBootstrapInlinePayload);
    }

    public function clearInitialHistBootstrapInlinePayload()
    {
        unset($this->initialHistBootstrapInlinePayload);
    }

    




    public function setInitialHistBootstrapInlinePayload($var)
    {
        GPBUtil::checkString($var, False);
        $this->initialHistBootstrapInlinePayload = $var;

        return $this;
    }

    



    public function getPeerDataRequestSessionId()
    {
        return isset($this->peerDataRequestSessionId) ? $this->peerDataRequestSessionId : '';
    }

    public function hasPeerDataRequestSessionId()
    {
        return isset($this->peerDataRequestSessionId);
    }

    public function clearPeerDataRequestSessionId()
    {
        unset($this->peerDataRequestSessionId);
    }

    




    public function setPeerDataRequestSessionId($var)
    {
        GPBUtil::checkString($var, True);
        $this->peerDataRequestSessionId = $var;

        return $this;
    }

    



    public function getFullHistorySyncOnDemandRequestMetadata()
    {
        return $this->fullHistorySyncOnDemandRequestMetadata;
    }

    public function hasFullHistorySyncOnDemandRequestMetadata()
    {
        return isset($this->fullHistorySyncOnDemandRequestMetadata);
    }

    public function clearFullHistorySyncOnDemandRequestMetadata()
    {
        unset($this->fullHistorySyncOnDemandRequestMetadata);
    }

    




    public function setFullHistorySyncOnDemandRequestMetadata($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\Message\FullHistorySyncOnDemandRequestMetadata::class);
        $this->fullHistorySyncOnDemandRequestMetadata = $var;

        return $this;
    }

    



    public function getEncHandle()
    {
        return isset($this->encHandle) ? $this->encHandle : '';
    }

    public function hasEncHandle()
    {
        return isset($this->encHandle);
    }

    public function clearEncHandle()
    {
        unset($this->encHandle);
    }

    




    public function setEncHandle($var)
    {
        GPBUtil::checkString($var, True);
        $this->encHandle = $var;

        return $this;
    }

    



    public function getMessageAccessStatus()
    {
        return $this->messageAccessStatus;
    }

    public function hasMessageAccessStatus()
    {
        return isset($this->messageAccessStatus);
    }

    public function clearMessageAccessStatus()
    {
        unset($this->messageAccessStatus);
    }

    




    public function setMessageAccessStatus($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\Message\HistorySyncMessageAccessStatus::class);
        $this->messageAccessStatus = $var;

        return $this;
    }

}

